package cn.cloudcore.iprotect.plugin;

import android.graphics.Color;

public class CEditTextAttrSet {
    
    final public static short SOFT_KBD_QWERTY               = 0;
    final public static short SOFT_KBD_MONEY                = 1;
    final public static short SOFT_KBD_NUMBER               = 2;
    final public static short SOFT_KBD_NUMBER_ONLY          = 3;
    
    final public static short SOFT_KBD_QWERTY_ALPHA_LOWER   = 0;
    final public static short SOFT_KBD_QWERTY_ALPHA_UPPER   = 1;
    final public static short SOFT_KBD_QWERTY_SYMBOL_1      = 2;
    final public static short SOFT_KBD_QWERTY_SYMBOL_2      = 3;
    
    final public static short SOFT_KBD_NO_EDITTEXT          = 0;
    final public static short SOFT_KBD_WITH_EDITTEXT        = 1;
    
    final public static short CONTENT_TYPE_INPUT_ANY        = 0x00;
    final public static short CONTENT_TYPE_INPUT_NUM        = 0x01;
    final public static short CONTENT_TYPE_INPUT_LETTER     = 0x02;
    final public static short CONTENT_TYPE_INPUT_PUNCT      = 0x04;
    
    final public static short WORK_MODE_FOR_DEVELOPMENT     = 0x00;
    final public static short WORK_MODE_FOR_PRODUCT         = 0x01;
    final public static short WORK_MODE_FOR_PRODUCT_ADVANCE = 0x02;
    final public static short WORK_MODE_FOR_PRODUCT_SM2     = 0x03;
    final public static short WORK_MODE_FOR_TEST            = 0x04;
    
    final public static short SOFT_KBD_MODE_KDOWN_CHANGE    = 0x00;
    final public static short SOFT_KBD_MODE_KDOWN_NOCHANGE  = 0x01;
    final public static short SOFT_KBD_MODE_KDOWN_NOPOP     = 0x02;

    final public static short SOFT_KBD_SWITCH_BETWEEN_ALPHA_SYMBOL = 0x00;
    final public static short SOFT_KBD_SWITCH_BETWEEN_ALPHA_NUMBER = 0x01;
    final public static short SOFT_KBD_SWITCH_ALPHA_SYMBOL_NUMBER  = 0x02;
    
    final public static short SOFT_KBD_FINISH_MODE_CLOSE    = 0x00;
    final public static short SOFT_KBD_FINISH_MODE_NOT_CLOSE= 0x01;
    
    final public static short SOFT_KBD_RANDOM_TYPE_ALL      = 0x00;
    final public static short SOFT_KBD_RANDOM_TYPE_NUMBER   = 0x01;
    
    public static float SOFT_KBD_HEIGHT_SCALE               = 4.0f; 
    
    public static float SOFT_WIDTH_HEIGHT_SCALE             = 0.5625f;
    
    public String name                  = "CC-iProtect plugin";
    public int textColor                = Color.BLACK;
    
    public short softkbdType            = SOFT_KBD_QWERTY;
    public short softkbdStype           = SOFT_KBD_QWERTY_ALPHA_LOWER;
    public short softkbdView            = SOFT_KBD_NO_EDITTEXT;
    public short softkbdMode            = SOFT_KBD_MODE_KDOWN_CHANGE;

    public char maskChar                = '*';
    public String accepts               = "[:print:]+";

    public short maxLength              = 12;
    public short minLength              = 6;

    public boolean kbdRandom            = true;
    public short   kbdRandomType        = SOFT_KBD_RANDOM_TYPE_ALL;
    public boolean kbdVibrator          = false;
    public boolean adjustTime           = false;
    
    public boolean clearWhenOpenKbd        = true;
    public boolean clearWhenOnPause        = true;
    public boolean outsideClose         = true;
    
    public boolean isZoomOut            = false;
    public float zoomOutScaleX          = 2.0f/3;
    public float zoomOutScaleY          = 2.0f/3;
    
    public short contentType            = CONTENT_TYPE_INPUT_ANY;
    public short switchMode             = SOFT_KBD_SWITCH_BETWEEN_ALPHA_SYMBOL;
    public short finishMode             = SOFT_KBD_FINISH_MODE_CLOSE;
    
    
    public CEditTextAttrSet(){}
    
    public CEditTextAttrSet(CEditTextAttrSet attrSet) {
        this.name                     = attrSet.name;
        this.textColor              = attrSet.textColor;
        
        this.softkbdType            = attrSet.softkbdType;
        this.softkbdStype           = attrSet.softkbdStype;
        this.softkbdView            = attrSet.softkbdView;
        this.softkbdMode            = attrSet.softkbdMode;

        this.maskChar               = attrSet.maskChar;
        this.accepts                = attrSet.accepts;

        this.maxLength              = attrSet.maxLength;
        this.minLength              = attrSet.minLength;

        this.kbdRandom              = attrSet.kbdRandom;
        this.kbdRandomType          = attrSet.kbdRandomType;
        
        this.kbdVibrator            = attrSet.kbdVibrator;
        this.adjustTime             = attrSet.adjustTime;
        
        this.clearWhenOpenKbd       = attrSet.clearWhenOpenKbd;
        this.clearWhenOnPause       = attrSet.clearWhenOnPause;
        this.outsideClose           = attrSet.outsideClose;
        
        this.isZoomOut              = attrSet.isZoomOut;
        this.zoomOutScaleX          = attrSet.zoomOutScaleX;
        this.zoomOutScaleY          = attrSet.zoomOutScaleY;
        
        this.contentType            = attrSet.contentType;
        this.switchMode             = attrSet.switchMode;
        this.finishMode             = attrSet.finishMode;
    }
}

