package cn.cloudcore.iprotect.plugin;

import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Field;
import java.util.List;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.app.Activity;
import android.app.ActivityManager;
import android.app.ActivityManager.RunningAppProcessInfo;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.res.AssetManager;
import android.content.res.Configuration;
import android.graphics.Color;
import android.graphics.PixelFormat;
import android.graphics.drawable.Drawable;
import android.opengl.GLSurfaceView;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.Vibrator;
import android.support.v4.content.LocalBroadcastManager;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.Toast;


public class CKbdActivity extends Activity {
    private String CKBD_RECEIVED = "CKBD.ACTION_EDIT.HANDLE";
    private String CET_RECEIVED = "CET.ACTION_EDIT.HANDLE";
    private final short CKBD_ACTIVITY_CLOSE = 1;
    private final short CKBD_ACTIVITY_OPEN = 2;
    private CKbdReceiver commandReceiver;

    private RelativeLayout rootLayout;
    private RelativeLayout topLayout, btmLayout;
    
    private final int LAYOUT_ROOT_ID = 0x10001;
    private final int LAYOUT_TOP_ID  = 0x10002;
    private final int LAYOUT_BTM_ID  = 0x10003;
    

    private GLSurfaceView kbdPopTopView;
    private GLSurfaceView kbdPopView;
    private GLSurfaceView kbdView;
    private CKbdJniLib ckbd;
    
    private boolean activity_flag = true;
    
    private Vibrator vibrator;
    private boolean vibrator_flag;
    private boolean pop_flag = true;
    
    private short softkbdType;
    private short softkbdView;
    private short finishMode;
    
    private int phoneWidth;
    private int phoneHeight;
    private int kbdHeight;
    private int kbdWidth;
    
    private boolean isZoomOut = false;
    private float   zoomOutScaleX = 2.0f / 3;
    private float   zoomOutScaleY = 2.0f / 3;
    private boolean clearWhenOnPause = true;
    private int vertical;
    
    private String[] messages;
    private Context ckbdContext;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        
        if (Build.VERSION.SDK_INT > Build.VERSION_CODES.HONEYCOMB_MR2) {
            getWindow().addFlags(WindowManager.LayoutParams.FLAG_SECURE);
        }
        
        
        ckbdContext = getApplicationContext();

        compaticityJudge();
        rootLayoutInit();
        setContentView(rootLayout);
        
        
        keyboardAttrsInit();

        keyboardLayoutInit();
        multiFuncLayoutInit();
        
        RelativeLayout.LayoutParams kbdParams = new RelativeLayout.LayoutParams(
                RelativeLayout.LayoutParams.MATCH_PARENT, 
                RelativeLayout.LayoutParams.WRAP_CONTENT);
        kbdParams.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM);

        RelativeLayout.LayoutParams topParams = new RelativeLayout.LayoutParams(
                RelativeLayout.LayoutParams.MATCH_PARENT,
                RelativeLayout.LayoutParams.WRAP_CONTENT);
        topParams.addRule(RelativeLayout.ABOVE, LAYOUT_BTM_ID);
        
        rootLayout.addView(btmLayout, kbdParams);
        
        if (pop_flag == true)
            rootLayout.addView(topLayout, topParams);
        
        rootLayout.setOnTouchListener(rootLayoutListener);
        kbdView.setOnTouchListener(kbdViewListener);
        
        setEditTextContent();
        
        sendOpenInfo();
        sendUpdateInfo(CKBD_ACTIVITY_OPEN);
    }
    
    private void refreshCKbdView() {
        
        if (Build.VERSION.SDK_INT > Build.VERSION_CODES.JELLY_BEAN_MR2)
            return;
        
        new Thread(new Runnable() {
            
            public void run() {
                long startTime = System.currentTimeMillis();
                long interval = 10;
                
                while (interval < 300) {
                    long curTime = System.currentTimeMillis();
                    if (curTime - startTime < interval - 5) {
                        try {
                            Thread.sleep(interval);
                            continue;
                        } catch (InterruptedException e) {}
                    }
                    
                    interval += interval;
                    mainHandler.sendEmptyMessage(10001);
                }
                
            }
        }).start();
    }
    
    private void compaticityJudge() {
//        Log.d("MODEL", Build.MODEL);
//        Log.d("VERSION SDK", Build.VERSION.SDK);
//        Log.d("VERSION RELEASE", Build.VERSION.RELEASE);
        
        String phoneModel = Build.MODEL;
        int versionSDK = Build.VERSION.SDK_INT;
        
        if (phoneModel.equals("meizu_m9") == true) {
            if (versionSDK <= 8) {
                pop_flag = false;
            }
        }
//        if (phoneModel.equals("SC-03E") == true) {
//            pop_flag = false;
//        }
    }
    
    private void rootLayoutInit()
    {
        rootLayout = new RelativeLayout(this);
        rootLayout.setId(LAYOUT_ROOT_ID);
        
        rootLayout.setGravity(Gravity.BOTTOM);
        rootLayout.setBackgroundColor(Color.TRANSPARENT);
    }
    
    private  View.OnTouchListener rootLayoutListener = new View.OnTouchListener() {
        
        public boolean onTouch(View v, MotionEvent event) {
            if (event.getAction() ==  MotionEvent.ACTION_UP) {

                float border;
                if (softkbdView == CEditTextAttrSet.SOFT_KBD_NO_EDITTEXT) {
                    border = phoneHeight - kbdHeight - kbdHeight / 4 * 0.3f;
                } else {
                    border = phoneHeight - kbdHeight - kbdHeight / 4 * 1.3f;
                }
                
                if (event.getY() > border)
                    return true;
                
                if (activity_flag == true) {
                    ckbd.setSurfaceClose();
                    CKbdActivity.this.finish();
                    sendCloseInfo(1, event.getX(), event.getY());
                    sendUpdateInfo(CKBD_ACTIVITY_CLOSE);
                    activity_flag = false;
                }
            }
            
            return true;
        }
    };
    
    private  View.OnTouchListener kbdViewListener = new View.OnTouchListener() {
        
        public boolean onTouch(View v, MotionEvent event) {
            int retval;
            
            if (event.getAction() ==  MotionEvent.ACTION_DOWN || event.getAction() == MotionEvent.ACTION_UP ||
                    event.getAction() == MotionEvent.ACTION_MOVE) {
                retval = ckbd.touchEvent(event.getAction(),
                            event.getX(), event.getY());
                
                if (event.getY() < 0.1 || event.getX() < 0.1) return true;
                
                if (vibrator_flag == true || retval != -1) {
                    if (event.getAction() == MotionEvent.ACTION_DOWN) {
                            vibrator = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);
                            vibrator.vibrate(60);
                    }
                } 
                
                if (retval == -1) {
                    if (ckbd.getPlaitextLen() == 0) {
                        sendUpdateInfo(retval);
                    }
                    return true;
                }
                if (retval == 1) {
                    if (activity_flag == true) {
                        sendCloseInfo(2, 0.0f, 0.0f);
                        sendUpdateInfo(CKBD_ACTIVITY_CLOSE);
                        if (finishMode == CEditTextAttrSet.SOFT_KBD_FINISH_MODE_CLOSE) {
                            ckbd.setSurfaceClose();
                            CKbdActivity.this.finish();
                            activity_flag = false;
                            return true;
                        }
                    }
                }
                
                if (retval == 2) {
                    if (activity_flag == true) {
                        sendCloseInfo(3, 0.0f, 0.0f);
                        sendUpdateInfo(CKBD_ACTIVITY_CLOSE);
                        if (finishMode == CEditTextAttrSet.SOFT_KBD_FINISH_MODE_CLOSE) {
                            ckbd.setSurfaceClose();
                            CKbdActivity.this.finish();
                            activity_flag = false;
                            return true;
                        }
                    }
                }
                
                if (retval == 0x80001) {
                    //Toast.makeText(ckbdContext, "提醒：安全输入键盘正被监控！", Toast.LENGTH_SHORT).show();
                    Toast.makeText(ckbdContext, messages[1], Toast.LENGTH_SHORT).show();
                }
                
                checkDebugState();
                sendUpdateInfo(retval);
                sendUpdateInfo();
            }
            
            setEditTextContent();
            
            return false;
        }
    };
    
    private void keyboardAttrsInit()
    {
        Bundle bundle = this.getIntent().getExtras();
        vibrator_flag = bundle.getBoolean("kbdVibrator");
        softkbdView = bundle.getShort("softkbdView");
        softkbdType = bundle.getShort("softkbdType");
        finishMode = bundle.getShort("finishMode");
        boolean popMode = bundle.getBoolean("popMode");
        if (popMode == false) pop_flag = false;
        
        isZoomOut = bundle.getBoolean("isZoomOut");
        zoomOutScaleX = bundle.getFloat("zoomOutScaleX");
        zoomOutScaleY = bundle.getFloat("zoomOutScaleY");
        clearWhenOnPause = bundle.getBoolean("clearWhenOnPause");
        
        ckbd = new CKbdJniLib(getIntent().getExtras().getString("cEditTextName"));
        if (ckbd.getHeightType() == 1) {
            CEditTextAttrSet.SOFT_WIDTH_HEIGHT_SCALE = 0.6818f;
        } else if (ckbd.getHeightType() == 2) {
            CEditTextAttrSet.SOFT_WIDTH_HEIGHT_SCALE = 0.6429f;
        } else {
            CEditTextAttrSet.SOFT_KBD_HEIGHT_SCALE   = 0.5625f;
        }
        
        DisplayMetrics metrics = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(metrics);
        phoneWidth = metrics.widthPixels;
        phoneHeight = metrics.heightPixels;
        
        kbdWidth = phoneWidth;
        if (phoneWidth < phoneHeight) {
            vertical = 1;
            //kbdHeight = Float.valueOf(phoneHeight * CEditTextAttrSet
            //        .SOFT_KBD_HEIGHT_SCALE / 10).intValue();
            kbdHeight = (int) (kbdWidth * 4 / 10 / CEditTextAttrSet.SOFT_WIDTH_HEIGHT_SCALE);
            
        } else {
            vertical = 0;
            kbdHeight = Float.valueOf(phoneHeight * CEditTextAttrSet
                    .SOFT_KBD_HEIGHT_SCALE / 8).intValue();
            
            if (isZoomOut) {
                kbdHeight = (int)(kbdHeight * zoomOutScaleY);
                kbdWidth = (int)(kbdWidth * zoomOutScaleX);
            }
        }
        
        
    }
    
    private void multiFuncLayoutInit()
    {
        topLayout = new RelativeLayout(this);
        topLayout.setId(LAYOUT_TOP_ID);
        
        //Log.e("multiFuncLayoutInit", "softkbdView:" + softkbdView);
        if (softkbdView == CEditTextAttrSet.SOFT_KBD_NO_EDITTEXT) {
            topLayout.setBackgroundColor(Color.TRANSPARENT);
        }

        FrameLayout multiLayout = new FrameLayout(this);
        FrameLayout.LayoutParams multiParams = new FrameLayout.LayoutParams(
                FrameLayout.LayoutParams.MATCH_PARENT, kbdHeight/4);
        topLayout.addView(multiLayout, multiParams);
        
        
        if (softkbdView == CEditTextAttrSet.SOFT_KBD_NO_EDITTEXT) {
            if (softkbdType == CEditTextAttrSet.SOFT_KBD_QWERTY) {
                LinearLayout deckLayout = new LinearLayout(this);
                deckLayout.setBackgroundColor(Color.rgb(0xd4, 0xd7, 0xda));
                
                int deckHeight = kbdHeight/50;
                if (vertical == 0) deckHeight = kbdHeight / 32;
                RelativeLayout.LayoutParams etParams = new RelativeLayout.LayoutParams(
                        RelativeLayout.LayoutParams.MATCH_PARENT, deckHeight);
                etParams.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM);
                
                RelativeLayout layout = new RelativeLayout(this);
                layout.addView(deckLayout, etParams);
                
                multiLayout.addView(layout);
            }
        }
        
        if (softkbdView == CEditTextAttrSet.SOFT_KBD_NO_EDITTEXT) {
            rootLayout.setBackgroundColor(Color.argb(0, 0, 0, 0));
        } else {
            rootLayout.setBackgroundColor(Color.argb(120, 0, 0, 0));
        }
        
        kbdPopView = new GLSurfaceView(this);
        kbdPopView.setSecure(true);
        if (softkbdView == CEditTextAttrSet.SOFT_KBD_NO_EDITTEXT) {
            //kbdPopView.setZOrderOnTop(true);
            kbdPopView.setEGLConfigChooser(8, 8, 8, 8, 16, 0);
            kbdPopView.getHolder().setFormat(PixelFormat.TRANSLUCENT);
        }
        kbdPopView.setRenderer(kbdPopRenderer);
        
        FrameLayout.LayoutParams kbdPopParams = new FrameLayout.LayoutParams(
                FrameLayout.LayoutParams.MATCH_PARENT,
                FrameLayout.LayoutParams.MATCH_PARENT);
        multiLayout.addView(kbdPopView, kbdPopParams);

        kbdPopTopView = new GLSurfaceView(this);
        kbdPopTopView.setSecure(true);
        //if (softkbdView == CEditTextAttrSet.SOFT_KBD_NO_EDITTEXT) {
            kbdPopTopView.setZOrderOnTop(true);
            kbdPopTopView.setEGLConfigChooser(8, 8, 8, 8, 16, 0);
            kbdPopTopView.getHolder().setFormat(PixelFormat.TRANSLUCENT);
        //}
        kbdPopTopView.setRenderer(kbdPopTopRenderer);
        kbdPopTopView.bringToFront();
        multiLayout.addView(kbdPopTopView, kbdPopParams);
        kbdPopTopView.bringToFront();
    }
    
    private void keyboardLayoutInit()
    {
        btmLayout = new RelativeLayout(this);
        btmLayout.setId(LAYOUT_BTM_ID);
        
        btmLayout.setBackgroundColor(Color.TRANSPARENT);
        
        messages = ckbd.getStringMessages();
        ckbd.setPopMode(pop_flag);
        if (vertical == 0) {
            if (softkbdType != CEditTextAttrSet.SOFT_KBD_QWERTY) {
                ckbd.setKbdType(CEditTextAttrSet.SOFT_KBD_QWERTY);
            }
        }
        
        kbdView = new GLSurfaceView(this);
        kbdView.setSecure(true);
        kbdView.setBackgroundDrawable(null);
        kbdView.setRenderer(kbdRenderer);
        
        btmLayout.setGravity(Gravity.CENTER_HORIZONTAL);
        btmLayout.addView(kbdView, kbdWidth, kbdHeight);
        commandReceiver = new CKbdReceiver();
    }
    
    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        
        int kbdHeight;
        DisplayMetrics metrics = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(metrics);
        phoneWidth = metrics.widthPixels;
        phoneHeight = metrics.heightPixels;
        
        if (ckbd.getHeightType() == 1) {
            CEditTextAttrSet.SOFT_WIDTH_HEIGHT_SCALE = 0.6818f;
        } else if (ckbd.getHeightType() == 2) {
            CEditTextAttrSet.SOFT_WIDTH_HEIGHT_SCALE = 0.6429f;
        } else {
            CEditTextAttrSet.SOFT_KBD_HEIGHT_SCALE   = 0.5625f;
        }
        
        if (phoneWidth < phoneHeight) {
            vertical = 1;
            //kbdHeight = Float.valueOf(phoneHeight * CEditTextAttrSet
              //      .SOFT_KBD_HEIGHT_SCALE / 10).intValue();
            
            kbdHeight = (int) (kbdWidth * 4 / 10 / CEditTextAttrSet.SOFT_WIDTH_HEIGHT_SCALE);
            
            if (softkbdView == CEditTextAttrSet.SOFT_KBD_NO_EDITTEXT) {
                //topLayout.setVisibility(View.INVISIBLE);
                rootLayout.setBackgroundColor(Color.argb(10, 0, 0, 0));
            } else {
                //topLayout.setVisibility(View.VISIBLE);
                rootLayout.setBackgroundColor(Color.argb(120, 0, 0, 0));
            }
        } else {
            vertical = 0;
            topLayout.setVisibility(View.VISIBLE);
            rootLayout.setBackgroundColor(Color.argb(120, 0, 0, 0));
            
            kbdHeight = Float.valueOf(phoneHeight * CEditTextAttrSet
                    .SOFT_KBD_HEIGHT_SCALE / 8).intValue();
        }
          
        LinearLayout.LayoutParams lp = new LinearLayout.LayoutParams(
                phoneWidth, kbdHeight);
        kbdView.setLayoutParams(lp);
    }

    @Override
    public void onStart() {
        super.onStart();
        
        IntentFilter filter=new IntentFilter();
        String receiverHandle = CKBD_RECEIVED + "_" + ckbd.kbd_handle;
        filter.addAction(receiverHandle);  
        
        LocalBroadcastManager lbm = LocalBroadcastManager.getInstance(this);
        lbm.registerReceiver(commandReceiver, filter);
    }

    @Override
    protected void onPause() {        
        super.onPause();
        kbdView.onPause();
    }
    
    @Override
    protected void onStop() {
        super.onStop();
        
        if (isApplicationBackground(getApplicationContext())) {
            if (clearWhenOnPause) {
                ckbd.clearPlaintext();
                sendUpdateInfo(0);
            }
        }
    }

    @Override
    public void onDestroy() {
        LocalBroadcastManager lbm = LocalBroadcastManager.getInstance(this);
        lbm.unregisterReceiver(commandReceiver);
        
        super.onDestroy();
    }
    
    @Override
    protected void onResume() {
        super.onResume();
        kbdView.onResume();
        
        //checkDebugState();
    }
    
    public static boolean isApplicationBackground(Context context) {
        ActivityManager activityManager = (ActivityManager) context.getSystemService(Context.ACTIVITY_SERVICE);
        List<RunningAppProcessInfo> appProcesses = activityManager.getRunningAppProcesses();
        for (RunningAppProcessInfo appProcess : appProcesses) {
            if (appProcess.processName.equals(context.getPackageName())) {
                if (appProcess.importance == RunningAppProcessInfo.IMPORTANCE_FOREGROUND) {
                    //Logger.i("处于前台:" + appProcess.processName);
                    return false;
                } else {
                    //Logger.i("处于后台:" + appProcess.processName);
                    return true;
                }
            }
        }
        return false;
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            if (activity_flag == true) {
                sendCloseInfo(0, 0.0f, 0.0f);
                sendUpdateInfo(CKBD_ACTIVITY_CLOSE);
                activity_flag = false;
                
                ckbd.setSurfaceClose();
                this.finish();
            }
        }
        
        return true;
    }
    
    private void checkDebugState() {
        //final String content = "提醒：检测到测试器，输入可能被监听!";
        if (android.os.Debug.isDebuggerConnected()) { //检测调试器
            //Toast.makeText(ckbdContext, content, Toast.LENGTH_SHORT).show();
            Toast.makeText(ckbdContext, messages[0], Toast.LENGTH_SHORT).show();
        }
    }
        
    private void setEditTextContent() {
        //cEditText.setText("");
        for (int i = 0; i < ckbd.getPlaitextLen(); i++) {
            //cEditText.append(maskStr, 0, 1);
        }
    }

    
    private GLSurfaceView.Renderer kbdRenderer = new GLSurfaceView.Renderer() {

        public void onSurfaceCreated(GL10 gl, EGLConfig config) {
                ckbd.setSurfaceCreated();
        }

        public void onSurfaceChanged(GL10 gl, int width, int height) {
                ckbd.setSurfaceChanged(width, height, vertical);
                refreshCKbdView();
        }

        public void onDrawFrame(GL10 gl) {
                ckbd.setDrawFrame();
        }
    };
    
    private GLSurfaceView.Renderer kbdPopRenderer = new GLSurfaceView.Renderer() {
        
        public void onSurfaceCreated(GL10 gl, EGLConfig config) {
            ckbd.setPopSurfaceCreated();
        }
        
        public void onSurfaceChanged(GL10 gl, int width, int height) {
            ckbd.setPopSurfaceChanged(width, height);            
        }
        
        public void onDrawFrame(GL10 gl) {
            if (softkbdView == CEditTextAttrSet.SOFT_KBD_NO_EDITTEXT) 
                ckbd.setPopDrawFrame(false);
            else
                ckbd.setPopDrawFrame(true);
        }
    };
    
    private GLSurfaceView.Renderer kbdPopTopRenderer = new GLSurfaceView.Renderer() {
        
        public void onSurfaceCreated(GL10 gl, EGLConfig config) {
            ckbd.setPopTopSurfaceCreated();
        }
        
        public void onSurfaceChanged(GL10 gl, int width, int height) {
            ckbd.setPopTopSurfaceChanged(width, height);          
        }
        
        public void onDrawFrame(GL10 gl) {
            ckbd.setPopTopDrawFrame();
        }
    };

    
    public class CKbdReceiver extends BroadcastReceiver {
        String closeCommand = "close";
        String command;
        
        int kbdHandle;
        
        @Override
        public void onReceive(Context context, Intent intent) {

            String receiverHandle = CKBD_RECEIVED + "_" + ckbd.kbd_handle; 
            if (intent.getAction().equals( receiverHandle )) {
                kbdHandle = intent.getIntExtra("CKbdHandle", -1);

                if (kbdHandle == ckbd.getNativeHandle()) {
                    command = intent.getStringExtra("CKbdCommand");

                    if (command.compareTo(closeCommand) == 0) {
                        if (activity_flag == true) {
                            
                            sendCloseInfo(0, 0.0f, 0.0f);
                            sendUpdateInfo(CKBD_ACTIVITY_CLOSE);
                            
                            ckbd.setSurfaceClose();
                            CKbdActivity.this.finish();
                            
                            activity_flag = false;
                        }
                    }
                }
            }
        }
    }
    
    private void sendUpdateInfo(int flag) {
        Intent intent = new Intent();
        String receiverHandle = CET_RECEIVED + "_" + ckbd.kbd_handle;
        intent.setAction(receiverHandle);
        intent.putExtra("CKbdHandle", ckbd.kbd_handle);
        
        if (flag == CKBD_ACTIVITY_CLOSE)
            intent.putExtra("CKbdInfo", "CloseInfo");
        else if (flag == CKBD_ACTIVITY_OPEN)
            intent.putExtra("CKbdInfo", "OpenInfo");
        else
            intent.putExtra("CKbdInfo", "UpdateInfo");

        LocalBroadcastManager  lbm = LocalBroadcastManager.getInstance(this);
        lbm.sendBroadcast(intent);
    }
    
    private void sendUpdateInfo() {
        String receiver_action = "cn.cloudcore.iprotect.plugin.ckbd";
        Intent intent = new Intent();
        intent.setAction(receiver_action);
        intent.putExtra("CKbdName", ckbd.kbd_name);
        intent.putExtra("CKbdInfo", "UpdateInfo");
        
        intent.putExtra("CKbdFlag", String.format("%d", 0));

        LocalBroadcastManager  lbm = LocalBroadcastManager.getInstance(this);
        lbm.sendBroadcast(intent);
    }
    
    private void sendCloseInfo(int flag, float x, float y) {
        String receiver_action = "cn.cloudcore.iprotect.plugin.ckbd";
        Intent intent = new Intent();
        intent.setAction(receiver_action);
        intent.putExtra("CKbdName", ckbd.kbd_name);
        intent.putExtra("CKbdInfo", "CloseInfo");
        
        intent.putExtra("CKbdFlag", String.format("%d", flag));
        intent.putExtra("CKbdEventX", x);
        intent.putExtra("CKbdEventY", y);

        LocalBroadcastManager  lbm = LocalBroadcastManager.getInstance(this);
        lbm.sendBroadcast(intent);
    }
    
    private void sendOpenInfo() {
        String receiver_action = "cn.cloudcore.iprotect.plugin.ckbd";
        Intent intent = new Intent();
        intent.setAction(receiver_action);
        intent.putExtra("CKbdName", ckbd.kbd_name);
        intent.putExtra("CKbdInfo", "OpenInfo");

        LocalBroadcastManager  lbm = LocalBroadcastManager.getInstance(this);
        lbm.sendBroadcast(intent);
        
        Log.e("CKbdActivity", "CKbdActivity:" + ckbd.kbd_name);
        Log.e("CKbdActivity", "CKbdActivity: OpenInfo");
    }
    
    private Handler mainHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
            case 10001:
                kbdView.invalidate();
                break;
            }
        }
    };
    
    
    private static Drawable getDrawableFromAssets(Context context,
            String imageFileName) {
        Drawable result = null;
        AssetManager assetManager = context.getAssets();
        InputStream is = null;
        try {
            is = assetManager.open(imageFileName);
            result = Drawable.createFromStream(is, null);
            is.close();
            is = null;
        } catch (IOException e) {
            e.printStackTrace();
        }
        return result;
    }
    
    public int getFileId(String xmlFile, String xmlName) {
        Class localClass = null;
        //
        int index = xmlName.indexOf('.');
        if (index > -1){
            xmlName = xmlName.substring(0, index);
        }
        try {
            localClass = Class.forName(ckbdContext.getPackageName() + ".R$"
                    + xmlFile);
        } catch (ClassNotFoundException exception) {
            exception.printStackTrace();
            return 0;
        }
        Field localField = null;
        try {
            System.out.println("path:" + ckbdContext.getPackageName() + ".R$"+ xmlFile);
            System.out.println("xmlName:" + xmlName);
            localField = localClass.getField(xmlName);
        } catch (SecurityException exception) {
            exception.printStackTrace();
            return 0;
        } catch (NoSuchFieldException exception) {
            exception.printStackTrace();
            return 0;
        }
        try {
            return Integer.parseInt(localField.get(localField.getName())
                    .toString());
        } catch (NumberFormatException exception) {
            exception.printStackTrace();
            return 0;
        } catch (IllegalArgumentException exception) {
            exception.printStackTrace();
            return 0;
        } catch (IllegalAccessException exception) {
            exception.printStackTrace();
            return 0;
        }
    }
}
