package cn.cloudcore.iprotect.plugin;

import java.util.Iterator;
import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import org.json.JSONObject;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.res.Configuration;
import android.graphics.Color;
import android.graphics.PixelFormat;
import android.opengl.GLSurfaceView;
import android.os.Build;
import android.os.Bundle;
import android.os.Vibrator;
import android.support.v4.content.LocalBroadcastManager;
import android.util.DisplayMetrics;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.FrameLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

public class CKbdForPayActivity extends Activity {
    
    public static final int ACT_FINISH            = 0;
    public static final int ACT_CANCEL            = 3;
    public static final int ACT_SWITH            = 110;
    
    private String CKBD_RECEIVED = "CKBD.ACTION_EDIT.HANDLE";
    private String CET_RECEIVED = "CET.ACTION_EDIT.HANDLE";
    private final short CKBD_ACTIVITY_CLOSE = 1;
    private final short CKBD_ACTIVITY_OPEN = 2;
    private CKbdReceiver commandReceiver;

    private GLSurfaceView kbdInputView;
    private GLSurfaceView kbdPopTopView;
    private GLSurfaceView kbdPopView;
    private GLSurfaceView kbdView;
    private CKbdJniLib ckbd;
    
    private boolean activity_flag = true;
    
    private Vibrator vibrator;
    private boolean vibrator_flag;
    
    private int phoneWidth;
    private int phoneHeight;
    private int kbdHeight;
    private int kbdWidth;
    
    
    private String[] messages;
    private Context ckbdContext;
    
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        
        if (Build.VERSION.SDK_INT > Build.VERSION_CODES.GINGERBREAD_MR1) {
            getWindow().addFlags(WindowManager.LayoutParams.FLAG_SECURE);
        }
        ckbdContext = getApplicationContext();
        //setContentView(R.layout.activity_ckbd_for_pay);
        setContentView(getResources().getIdentifier("act_ckbd_for_pay", 
                "layout", getPackageName()));
        
        payKeyboardInit();
        keyboardAttrsInit();
        payMiddleInfoInit();
        
    };
    
    private void setKeyBoardProperty(String attrKey, Object attrValue) {
        
        final String kbdType           = "KEYBOARD_TYPE";
        final String kbdStyle          = "KEYBOARD_STYLE";
        final String kbdInputView      = "KEYBOARD_INPUT_VIEW";
        final String kbdClickMode      = "KEYBOARD_MODE";
        final String kbdMaskChar       = "KEYBOARD_MASK_CHAR";
        final String kbdAccepts        = "KEYBOARD_ACCEPTS";
        final String kbdMinLength      = "KEYBOARD_MINLENGTH";
        final String kbdMacLength      = "KEYBOARD_MAXLENGTH";
        final String kbdKeyRandom      = "KEYBOARD_KEY_RANDOM";
        final String kbdKeyRandomType  = "KEYBOARD_KEY_RANDOM_TYPE";
        final String kbdVibrator       = "KEYBOARD_VIBRATOR";
        
        //Log.i("setKeyBoardProperty", "attrKey:" + attrKey + "  attrValue:" + attrValue);
        
        if (attrKey.equalsIgnoreCase(kbdType)) {
            ckbd.setKbdType((short)Integer.parseInt(attrValue.toString()));
        } else if (attrKey.equalsIgnoreCase(kbdStyle)) {
            ckbd.setKbdStyle((short)Integer.parseInt(attrValue.toString()));
        } else if (attrKey.equalsIgnoreCase(kbdInputView)) {
        } else if (attrKey.equalsIgnoreCase(kbdMaskChar)) {
        } else if (attrKey.equalsIgnoreCase(kbdClickMode)) {
            ckbd.setKbdMode((short)Integer.parseInt(attrValue.toString()));
        } else if (attrKey.equalsIgnoreCase(kbdAccepts)) {
            ckbd.setAccepts(attrValue.toString());
        } else if (attrKey.equalsIgnoreCase(kbdMinLength)) {
             ckbd.setMinLength((short)Integer.parseInt(attrValue.toString()));
        } else if (attrKey.equalsIgnoreCase(kbdMacLength)) {
            ckbd.setMaxLength((short)Integer.parseInt(attrValue.toString()));
        } else if (attrKey.equalsIgnoreCase(kbdKeyRandom)) {
            ckbd.setKbdRandom(Boolean.parseBoolean(attrValue.toString()));
        } else if (attrKey.equalsIgnoreCase(kbdKeyRandomType)) {
            ckbd.setKbdRandomType(Short.parseShort(attrValue.toString()));
        } else if (attrKey.equalsIgnoreCase(kbdVibrator)) {
            vibrator_flag = Boolean.parseBoolean(attrValue.toString());
        }
    }
    
    private void keyboardAttrsInit()
    {
        try {
            JSONObject payInfo = new JSONObject(getIntent().getStringExtra("payInfo"));
            
            View payeeTransLayout = findViewById(getResources().getIdentifier("layout_payee_trans",
                    "id", getPackageName()));
            View payeePayLayout = findViewById(getResources().getIdentifier("layout_payee_pay",
                    "id", getPackageName()));
            View payeeLoadLayout = findViewById(getResources().getIdentifier("layout_payee_load",
                    "id", getPackageName()));
            View payeeCostLayout = findViewById(getResources().getIdentifier("layout_payee_cost",
                    "id", getPackageName()));
            View payeeInfoLayout = findViewById(getResources().getIdentifier("layout_payee_info",
                    "id", getPackageName()));
            
            String transPrice = payInfo.getString("TransPrice");
            ((TextView) findViewById(getResources().getIdentifier("trans_price",
                    "id", getPackageName()))).setText(transPrice);
            
            String acNo = payInfo.getString("PayeeAcNo");
            String tailAcNo = acNo.substring(acNo.length() - 4); 
            
            String PayeeType = payInfo.getString("PayeeType");
            if (PayeeType.equals("2")) {
                payeePayLayout.setVisibility(View.GONE);
                payeeTransLayout.setVisibility(View.GONE);
                payeeCostLayout.setVisibility(View.GONE);
                payeeInfoLayout.setVisibility(View.GONE);
                payeeLoadLayout.setVisibility(View.VISIBLE);
                
                
                ((TextView) findViewById(getResources().getIdentifier("payee_load_acno_tail",
                        "id", getPackageName()))).setText(tailAcNo);
                
            } else {
                payeeLoadLayout.setVisibility(View.GONE);
                
                ((TextView) findViewById(getResources().getIdentifier("payee_acno_tail",
                        "id", getPackageName()))).setText(tailAcNo);
                String BankName = payInfo.getString("BankName");
                ((TextView) findViewById(getResources().getIdentifier("payee_bank_name",
                        "id", getPackageName()))).setText(BankName);
                
                String PayeeName = payInfo.getString("PayeeName");
                
                
                if (PayeeType.equals("0")) {
                    payeeTransLayout.setVisibility(View.VISIBLE);
                    payeePayLayout.setVisibility(View.GONE);
                    
                    String PayeeCost = payInfo.getString("PayeeCost");    
                    ((TextView) findViewById(getResources().getIdentifier("payee_name_trans",
                            "id", getPackageName()))).setText(PayeeName);
                    ((TextView) findViewById(getResources().getIdentifier("payee_cost",
                            "id", getPackageName()))).setText(PayeeCost);
                } else {
                    payeePayLayout.setVisibility(View.VISIBLE);
                    payeeTransLayout.setVisibility(View.GONE);
                    payeeCostLayout.setVisibility(View.GONE);
                    
                    ((TextView) findViewById(getResources().getIdentifier("payee_name_pay",
                            "id", getPackageName()))).setText(PayeeName);
                }
                
            }
        } catch (Exception e) {}
        
        try {
            JSONObject kbdParam = new JSONObject(getIntent().getStringExtra("keyParam"));
            Iterator<String> kbdParamKeys = kbdParam.keys();
            while (kbdParamKeys.hasNext()) {
                String attrKey   = kbdParamKeys.next();
                String attrValue = kbdParam.getString(attrKey);
                setKeyBoardProperty(attrKey, attrValue);
            }
        } catch (Exception e) {}
        
        Bundle bundle = this.getIntent().getExtras();
        vibrator_flag = bundle.getBoolean("kbdVibrator");
    }
    
    private void payKeyboardInit() {
        
        DisplayMetrics metrics = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(metrics);
        phoneWidth = metrics.widthPixels;
        phoneHeight = metrics.heightPixels;
        
        kbdWidth = phoneWidth;
        kbdHeight = Float.valueOf(phoneHeight * CEditTextAttrSet
                .SOFT_KBD_HEIGHT_SCALE / 10).intValue();
        
        //RelativeLayout layout = (RelativeLayout) findViewById(R.id.layout_ckbd_for_pay);
        RelativeLayout layout = (RelativeLayout) findViewById(
                getResources().getIdentifier("layout_ckbd_for_pay", "id", getPackageName()));
        layout.setBackgroundColor(Color.TRANSPARENT);
        
        
        ckbd = new CKbdJniLib("KeyboardID4");
        ckbd.setFinishMode(CEditTextAttrSet.SOFT_KBD_FINISH_MODE_NOT_CLOSE);
        messages = ckbd.getStringMessages();
        
        kbdView = new GLSurfaceView(this);
        kbdView.setBackgroundDrawable(null);
        kbdView.setRenderer(kbdRenderer);
        kbdView.setOnTouchListener(kbdViewListener);
        
        layout.setGravity(Gravity.CENTER_HORIZONTAL);
        layout.addView(kbdView, kbdWidth, kbdHeight);
        commandReceiver = new CKbdReceiver();
        
//        ckbd.setAccepts(accepts);
//        ckbd.setMinLength(minLength);
//        ckbd.setMaxLength(maxLength);
//        
//        ckbd.setKbdRandom(kbdRandom);
//        ckbd.setKbdType(softkbdType);
//        ckbd.setKbdMode(finishMode);
//        ckbd.setKbdType(softkbdStype);
//        ckbd.setKbdStyle(softkbdStype);
    }
    
    private void payMiddleInfoInit() {
        View payClose = findViewById(getResources().getIdentifier(
                "pay_info_close", "id", getPackageName()));
        payClose.setOnClickListener(new View.OnClickListener() {
            
            public void onClick(View v) {
                //Log.e("payClose", "payClose");
                setResult(ACT_CANCEL);
                finish();
            }
        });
        
        View paySwitch = findViewById(getResources().getIdentifier(
                "pay_bank_switch", "id", getPackageName()));
        paySwitch.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //Log.e("paySwitch", "paySwitch");
                setResult(ACT_SWITH);
                finish();
            }
        });
        
        RelativeLayout layout = (RelativeLayout) findViewById(getResources().getIdentifier(
                "layout_ckbd", "id", getPackageName()));
        layout.setBackgroundColor(Color.TRANSPARENT);
        kbdPopView = new GLSurfaceView(this);
        //if (softkbdView == CEditTextAttrSet.SOFT_KBD_NO_EDITTEXT) {
            kbdPopView.setZOrderOnTop(true);
            kbdPopView.setEGLConfigChooser(8, 8, 8, 8, 16, 0);
            kbdPopView.getHolder().setFormat(PixelFormat.TRANSLUCENT);
        //}
        kbdPopView.setRenderer(kbdPopRenderer);
        
        FrameLayout.LayoutParams kbdPopParams = new FrameLayout.LayoutParams(
                FrameLayout.LayoutParams.MATCH_PARENT, kbdHeight / 4);
        //layout.addView(kbdPopView, kbdPopParams);

        kbdPopTopView = new GLSurfaceView(this);
        //if (softkbdView == CEditTextAttrSet.SOFT_KBD_NO_EDITTEXT) {
            kbdPopTopView.setZOrderOnTop(true);
            kbdPopTopView.setEGLConfigChooser(8, 8, 8, 8, 16, 0);
            kbdPopTopView.getHolder().setFormat(PixelFormat.TRANSLUCENT);
        //}
        kbdPopTopView.setRenderer(kbdPopTopRenderer);
        //kbdPopTopView.bringToFront();
        //layout.addView(kbdPopTopView, kbdPopParams);
        //kbdPopTopView.bringToFront();
        
        int buildVersion = Build.VERSION.SDK_INT;
//        if (versionSDK < 19) {
//            layout.addView(kbdPopView, kbdPopParams);
//            kbdPopView.bringToFront();
//            
//            layout.addView(kbdPopTopView, kbdPopParams);
//            kbdPopTopView.bringToFront();    
//        } else {
//            layout.addView(kbdPopTopView, kbdPopParams);
//            kbdPopTopView.bringToFront();
//            
//            layout.addView(kbdPopView, kbdPopParams);
//            kbdPopView.bringToFront();
//        }
        
        String manufacturer = Build.MANUFACTURER;
        if ("Xiaomi".equalsIgnoreCase(Build.MANUFACTURER)) {
            if (buildVersion > 22) {
                layout.addView(kbdPopView, kbdPopParams);
                kbdPopView.bringToFront();
                
                layout.addView(kbdPopTopView, kbdPopParams);
                kbdPopTopView.bringToFront();
            } else {
                layout.addView(kbdPopTopView, kbdPopParams);
                kbdPopTopView.bringToFront();
                
                layout.addView(kbdPopView, kbdPopParams);
                kbdPopView.bringToFront();
            }
        } else if ("samsung".equalsIgnoreCase(Build.MANUFACTURER)  
                    || buildVersion < 19) {
                layout.addView(kbdPopView, kbdPopParams);
                kbdPopView.bringToFront();
                
                layout.addView(kbdPopTopView, kbdPopParams);
                kbdPopTopView.bringToFront();
        } else {
            layout.addView(kbdPopTopView, kbdPopParams);
            kbdPopTopView.bringToFront();
            
            layout.addView(kbdPopView, kbdPopParams);
            kbdPopView.bringToFront();
        }
        
//        if (!("HUAWEI".equalsIgnoreCase(Build.MANUFACTURER) || 
//                "vivo".equalsIgnoreCase(Build.MANUFACTURER) || 
//                "oppo".equalsIgnoreCase(Build.MANUFACTURER)) ) {
//            if (versionSDK < 19) {
//                layout.addView(kbdPopTopView, kbdPopParams);
//                kbdPopTopView.bringToFront();
//                
//                layout.addView(kbdPopView, kbdPopParams);
//                kbdPopView.bringToFront();
//            } else {
//                layout.addView(kbdPopView, kbdPopParams);
//                kbdPopView.bringToFront();
//                
//                layout.addView(kbdPopTopView, kbdPopParams);
//                kbdPopTopView.bringToFront();
//            }
//        } else {
//            layout.addView(kbdPopTopView, kbdPopParams);
//            kbdPopTopView.bringToFront();
//            
//            layout.addView(kbdPopView, kbdPopParams);
//            kbdPopView.bringToFront();
//        }
        
        
        RelativeLayout input = (RelativeLayout) findViewById(getResources().getIdentifier(
                "layout_pay_info_input", "id", getPackageName()));
        kbdInputView  = new GLSurfaceView(this);
        kbdInputView.setRenderer(kbdInputRenderer);
        
        kbdPopParams.height = kbdHeight / 6;
        input.addView(kbdInputView, kbdPopParams);
    }
    
    
    
    private  View.OnTouchListener kbdViewListener = new View.OnTouchListener() {
        
        public boolean onTouch(View v, MotionEvent event) {
            int retval;
            
            if (event.getAction() ==  MotionEvent.ACTION_DOWN || event.getAction() == MotionEvent.ACTION_UP ||
                    event.getAction() == MotionEvent.ACTION_MOVE) {
                retval = ckbd.touchEvent(event.getAction(),
                            event.getX(), event.getY());
                
                if (event.getY() < 0.1 || event.getX() < 0.1) return true;
                
                if (vibrator_flag == true || retval != -1) {
                    if (event.getAction() == MotionEvent.ACTION_DOWN) {
                            vibrator = (Vibrator) getSystemService(VIBRATOR_SERVICE);
                            vibrator.vibrate(80);
                    }
                }
                
                if (retval == -1) return true;
                if (retval == 1) {
                    
                    short verify = ckbd.verify();
                    if (verify != 0 && verify != -4) {
                        String tipContent = "密码校验异常，请重新输入！";
                        if (verify == -1) {
                            tipContent = "密码为空，请输入支付密码！";
                        } else if (verify == -2) {
                            tipContent = "密码长度小于最小长度，请输入支付密码！";
                        } else if (verify == -3) {
                            tipContent = "密码内容含有不允许的字符，请重新输入！";
                        } else if (verify == -5) {
                            tipContent = "密码内容在字典过滤中，请重新输入！";
                        } else if (verify == -6) {
                            tipContent = "密码类型不匹配，请重新输入！";
                        } 
                            
                        Toast.makeText(CKbdForPayActivity.this, tipContent, 
                                Toast.LENGTH_SHORT).show();;
                        return false;
                    }
                    
                    if (activity_flag == true) {
                        sendCloseInfo(2, 0.0f, 0.0f);
                        sendUpdateInfo(CKBD_ACTIVITY_CLOSE);
                            ckbd.setSurfaceClose();
                            
                            setResult(ACT_FINISH);
                            CKbdForPayActivity.this.finish();
                            activity_flag = false;
                            return true;
                    }
                }
                
                if (retval == 0x80001) {
                    //Toast.makeText(ckbdContext, "提醒：安全输入键盘正被监控！", Toast.LENGTH_SHORT).show();
                    Toast.makeText(ckbdContext, messages[1], Toast.LENGTH_SHORT).show();
                }
                
                checkDebugState();
                sendUpdateInfo(retval);
            }
            
            return false;
        }
    };
    
    
    
    
    
    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
    }

    @Override
    public void onStart() {
        super.onStart();
        
        IntentFilter filter=new IntentFilter();
        String receiverHandle = CKBD_RECEIVED + "_" + ckbd.kbd_handle;
        filter.addAction(receiverHandle);  
        
        LocalBroadcastManager lbm = LocalBroadcastManager.getInstance(this);
        lbm.registerReceiver(commandReceiver, filter);
    }

    @Override
    protected void onPause() {        
        super.onPause();
        kbdView.onPause();
    }

    @Override
    public void onDestroy() {
        LocalBroadcastManager lbm = LocalBroadcastManager.getInstance(this);
        lbm.unregisterReceiver(commandReceiver);
        
        super.onDestroy();
    }
    
    @Override
    protected void onResume() {
        super.onResume();
        kbdView.onResume();
        
        //checkDebugState();
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            if (activity_flag == true) {
                sendCloseInfo(0, 0.0f, 0.0f);
                sendUpdateInfo(CKBD_ACTIVITY_CLOSE);
                activity_flag = false;
                
                ckbd.setSurfaceClose();
                setResult(ACT_CANCEL);
                this.finish();
            }
        }
        
        return true;
    }
    
    private void checkDebugState() {
        //final String content = "提醒：检测到测试器，输入可能被监听!";
        if (android.os.Debug.isDebuggerConnected()) { //检测调试器
            //Toast.makeText(ckbdContext, content, Toast.LENGTH_SHORT).show();
            Toast.makeText(ckbdContext, messages[0], Toast.LENGTH_SHORT).show();
        }
    }
        
    

    
    private GLSurfaceView.Renderer kbdRenderer = new GLSurfaceView.Renderer() {

        public void onSurfaceCreated(GL10 gl, EGLConfig config) {
                ckbd.setSurfaceCreated();
        }

        public void onSurfaceChanged(GL10 gl, int width, int height) {
                ckbd.setSurfaceChanged(width, height, 1);
        }

        public void onDrawFrame(GL10 gl) {
                ckbd.setDrawFrame();
        }
    };
    
    private GLSurfaceView.Renderer kbdPopRenderer = new GLSurfaceView.Renderer() {
        
        public void onSurfaceCreated(GL10 gl, EGLConfig config) {
            ckbd.setPopSurfaceCreated();
        }
        
        public void onSurfaceChanged(GL10 gl, int width, int height) {
            ckbd.setPopSurfaceChanged(width, height);            
        }
        
        public void onDrawFrame(GL10 gl) {
            ckbd.setPopDrawFrame(false);
        }
    };
    
    private GLSurfaceView.Renderer kbdPopTopRenderer = new GLSurfaceView.Renderer() {
        
        public void onSurfaceCreated(GL10 gl, EGLConfig config) {
            ckbd.setPopTopSurfaceCreated();
        }
        
        public void onSurfaceChanged(GL10 gl, int width, int height) {
            ckbd.setPopTopSurfaceChanged(width, height);          
        }
        
        public void onDrawFrame(GL10 gl) {
            ckbd.setPopTopDrawFrame();
        }
    };
    
    private GLSurfaceView.Renderer kbdInputRenderer = new GLSurfaceView.Renderer() {
        
        public void onSurfaceCreated(GL10 gl, EGLConfig config) {
            ckbd.setInputSurfaceCreated();
        }
        
        public void onSurfaceChanged(GL10 gl, int width, int height) {
            ckbd.setInputSurfaceChanged(width, height);            
        }
        
        public void onDrawFrame(GL10 gl) {
            ckbd.setInputDrawFrame();
        }
    };

    
    public class CKbdReceiver extends BroadcastReceiver {
        String closeCommand = "close";
        String command;
        
        int kbdHandle;
        
        @Override
        public void onReceive(Context context, Intent intent) {

            String receiverHandle = CKBD_RECEIVED + "_" + ckbd.kbd_handle; 
            if (intent.getAction().equals( receiverHandle )) {
                kbdHandle = intent.getIntExtra("CKbdHandle", -1);

                if (kbdHandle == ckbd.getNativeHandle()) {
                    command = intent.getStringExtra("CKbdCommand");

                    if (command.compareTo(closeCommand) == 0) {
                        if (activity_flag == true) {
                            
                            sendCloseInfo(0, 0.0f, 0.0f);
                            sendUpdateInfo(CKBD_ACTIVITY_CLOSE);
                            
                            ckbd.setSurfaceClose();
                            CKbdForPayActivity.this.finish();
                            
                            activity_flag = false;
                        }
                    }
                }
            }
        }
    }
    
    private void sendUpdateInfo(int flag) {
        Intent intent = new Intent();
        String receiverHandle = CET_RECEIVED + "_" + ckbd.kbd_handle;
        intent.setAction(receiverHandle);
        intent.putExtra("CKbdHandle", ckbd.kbd_handle);
        
        if (flag == CKBD_ACTIVITY_CLOSE)
            intent.putExtra("CKbdInfo", "CloseInfo");
        else if (flag == CKBD_ACTIVITY_OPEN)
            intent.putExtra("CKbdInfo", "OpenInfo");
        else
            intent.putExtra("CKbdInfo", "UpdateInfo");

        LocalBroadcastManager  lbm = LocalBroadcastManager.getInstance(this);
        lbm.sendBroadcast(intent);
    }
    
    private void sendCloseInfo(int flag, float x, float y) {
        String receiver_action = "cn.cloudcore.iprotect.plugin.ckbd";
        Intent intent = new Intent();
        intent.setAction(receiver_action);
        intent.putExtra("CKbdName", ckbd.kbd_name);
        intent.putExtra("CKbdInfo", "CloseInfo");
        
        intent.putExtra("CKbdFlag", String.format("%d", flag));
        intent.putExtra("CKbdEventX", x);
        intent.putExtra("CKbdEventY", y);

        LocalBroadcastManager  lbm = LocalBroadcastManager.getInstance(this);
        lbm.sendBroadcast(intent);
    }
    
    private void sendOpenInfo() {
        String receiver_action = "cn.cloudcore.iprotect.plugin.ckbd";
        Intent intent = new Intent();
        intent.setAction(receiver_action);
        intent.putExtra("CKbdName", ckbd.kbd_name);
        intent.putExtra("CKbdInfo", "OpenInfo");

        LocalBroadcastManager  lbm = LocalBroadcastManager.getInstance(this);
        lbm.sendBroadcast(intent);
    }
    
    
    
}
