package cn.cloudcore.iprotect.plugin;

import java.io.DataOutputStream;

import cn.cloudcore.iprotect.utils.CBuildConfig;

public class CKbdJniLib {
    
    public int kbd_handle = -1;
    public String kbd_name = null;
    public boolean isInitialized = false;
    
    public CKbdJniLib(String name) {
        kbd_handle = createNativeSession(name);
        kbd_name = name;
    }
    
    public void destroy() {
        destroyNativeSession(kbd_handle);
    }
    
    public void setSurfaceCreated() {
        isInitialized = true;
        setNativeSurfaceCreated(kbd_handle);
    }
    
    public void setDrawFrame() {
        setNativeDrawFrame(kbd_handle);
    }
    
    public void setSurfaceChanged( int width, int height, int vertical) {
        setNativeSurfaceChanged(kbd_handle, width, height, vertical);
    }
    
    public void setSurfaceClose() {
        setNativeSurfaceClose(kbd_handle);
    }
    
    public void setPopSurfaceCreated() {
        setNativePopSurfaceCreated(kbd_handle);
    }
    
    public void setPopDrawFrame(boolean isShowInput) {
        setNativePopDrawFrame(kbd_handle, isShowInput);
    }
    
    public void setPopSurfaceChanged( int width, int height) {
        setNativePopSurfaceChanged(kbd_handle, width, height);
    }
    
    public void setPopTopSurfaceCreated() {
        setNativePopTopSurfaceCreated(kbd_handle);
    }
    
    public void setPopTopDrawFrame() {
        setNativePopTopDrawFrame(kbd_handle);
    }
    
    public void setPopTopSurfaceChanged( int width, int height) {
        setNativePopTopSurfaceChanged(kbd_handle, width, height);
    }
    
    public void setInputSurfaceCreated() {
        setNativeInputSurfaceCreated(kbd_handle);
    }
    
    public void setInputDrawFrame() {
        setNativeInputDrawFrame(kbd_handle);
    }
    
    public void setInputSurfaceChanged( int width, int height) {
        setNativeInputSurfaceChanged(kbd_handle, width, height);
    }
    
    public int touchEvent(int type, float x, float y) {
        return setNativeTouchPos(kbd_handle, type, x, y);
    }
    
    public boolean publicKeyAppModulus(String keyModulus) {
        return setNativePublicKeyAppModulus(kbd_handle, keyModulus); 
    }
    public boolean publicKeyAppDER(String keyDer) {
        return setNativePublicKeyAppDER(kbd_handle, keyDer);
    }
    public boolean publicKeyAppBlob(String keyBlob) {
        return setNativePublicKeyAppBlob(kbd_handle, keyBlob);
    }
    
    public boolean publicKeyModulus(String keyModulus) {
        return setNativePublicKeyModulus(kbd_handle, keyModulus);
    }
    public boolean publicKeyDER(String keyDer) {
        return setNativePublicKeyDER(kbd_handle, keyDer);
    }
    public boolean publicKeyBlob(String keyBlob) {
        return setNativePublicKeyBlob(kbd_handle, keyBlob);
    }
    
    public boolean publicKeyECC(String x, String y) {
        return setNativePublicKeyECC(kbd_handle, x, y);
    }
    
    public void setAccepts(String accepts) {
        setNativeAccepts(kbd_handle, accepts);
    }
    
    public void setMinLength(short minlength) {
        setNativeMinLength(kbd_handle, minlength);
    }
    
    public void setMaxLength(short maxlength) {
        setNativeMaxLength(kbd_handle, maxlength);
    }
    
    public void setKbdRandom(boolean kbdRandom) {
        setNativeKbdRandom(kbd_handle, kbdRandom);
    }
    
    public void setKbdRandomType(short kbdRandomType) {
        setNativeKbdRandomType(kbd_handle, kbdRandomType);
    }
    
    public void setKbdVibrator(boolean kbdVibrator) {
        setNativeKbdVibrator(kbd_handle, kbdVibrator);
    }
    
    public boolean getKbdVibrator() {
        return getNativeKbdVibrator(kbd_handle);
    }

    public short getPlaitextLen() {
        return getNativeContentLen(kbd_handle);
    }
    
    public String getCiphertext(String timeStamp) {
        return getNativeContent(kbd_handle, timeStamp);
    }
    
    public String getPinCiphertext(String timeStamp) {
        return getNativePinContent(kbd_handle, timeStamp);
    }
    
    public int clearPlaintext() {
        return clearNativePlaintext(kbd_handle);
    }
    
    public char getComplexDegree() {
        return getNativeDegree(kbd_handle);
    }
    
    public long getVersion() {
        return getNativeVersion(kbd_handle);
    }
    
    public int getNativeHandle() {
        return kbd_handle;
    }
    
    public short verify() {
        return getNativeVerify(kbd_handle);
    }
    
    public void setContentType(int type) {
        setNativeContentType(kbd_handle, type);
    }
    
    public void setKbdType(short kbdType) {
        setNativeKbdType(kbd_handle, kbdType);
    }
    
    public void setKbdStyle(short kbdStyle) {
        setNativeKbdStyle(kbd_handle, kbdStyle);
    }
    
    public void setKbdMode(short kbdMode) {
        setNativeKbdMode(kbd_handle, kbdMode);
    }
    
    public String lastError() {
        return getNativeLastError(kbd_handle);
    }
    
    public void setChallengeCode(byte[] code) {
        setNativeChallengeCode(kbd_handle, code);
    }
    
    public void setCalcFactor(String factor) {
        setNativeKbdFactor(kbd_handle, factor);
    }

    public byte[] getEncryptedPinCode() {
        return getNativeEncryptedPinCode(kbd_handle);
    }
    
    public String getMeasureValue() {
        return getNativeMeasureValue(kbd_handle);
    }
    
    
    
    public String[] getStringMessages() {
        return getNativeMessages();
    }
    
    public void setMode(short mode) {
        setNativeMode(kbd_handle, mode);
    }
    
    public void setAlgorithmCode(String algorithmCode) {
        setNativeAlgorithmCode(kbd_handle, algorithmCode);
    }
    
    public void setHashRandom(String salt) {
        setNativeHashRandom(kbd_handle, salt);
    }
    
    public void setDictionaryFilter(String dictFilter) {
        setNativeDictionaryFilter(kbd_handle, dictFilter);
    }
    
    public void setPopMode(boolean popFlag) {
        setNativePopMode(kbd_handle, popFlag);
    }
    
    public void setSwitchMode(short mode) {
        setNativeSwitchMode(kbd_handle, mode);
    }
    
    public void setFinishMode(short mode) {
        setNativeFinishMode(kbd_handle, mode);
    }
    
    public short getEncryptType() {
        return getNativeEncryptType(kbd_handle);
    }
    
    public short getHeightType() {
        return getNativeHeightType();
    }
    
    
    public static boolean isRoot() {
        return checkRoot();
    }
    
    private synchronized static boolean checkRoot() {
        Process process = null;
        DataOutputStream os = null;
        try {
            process = Runtime.getRuntime().exec("su");
            os = new DataOutputStream(process.getOutputStream());
            os.writeBytes("exit\n");
            os.flush();
            int exitValue = process.waitFor();
            if (exitValue == 0) {
                return true;
            } else {
                return false;
            }
        } catch (Exception e) {
            return false;
        } finally {
            try {
                if (os != null) {
                    os.close();
                }
                process.destroy();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
    
    
    
    private native int createNativeSession(String name);
    private native void destroyNativeSession(int handle);
    
    private native void setNativeSurfaceCreated(int handle);
    private native void setNativeDrawFrame(int handle);
    private native void setNativeSurfaceChanged(int handle, int width, int height, int vertical);
    private native void setNativeSurfaceClose(int handle);
    
    private native void setNativePopSurfaceCreated(int handle);
    private native void setNativePopDrawFrame(int handle, boolean isShowInput);
    private native void setNativePopSurfaceChanged(int handle, int width, int height);
    
    private native void setNativeInputSurfaceCreated(int handle);
    private native void setNativeInputDrawFrame(int handle);
    private native void setNativeInputSurfaceChanged(int handle, int width, int height);
    
    private native void setNativePopTopSurfaceCreated(int handle);
    private native void setNativePopTopDrawFrame(int handle);
    private native void setNativePopTopSurfaceChanged(int handle, int width, int height);

    private native int setNativeTouchPos(int handle, int type, float x, float y);
    
    private native void setNativeAccepts(int handle, String accepts);
    private native void setNativeMinLength(int handle, short minlength);
    private native void setNativeMaxLength(int handle, short maxlength);
    private native void setNativeKbdRandom(int handle, boolean keyRandom);
    private native void setNativeKbdRandomType(int handle, short keyRandomType);
    
    private native void setNativeKbdVibrator(int handle, boolean kbdVibrator);
    private native boolean getNativeKbdVibrator(int handle);
    
    private native boolean setNativePublicKeyAppModulus(int handle, String keyModulus);
    private native boolean setNativePublicKeyAppDER(int handle, String keyDer);
    private native boolean setNativePublicKeyAppBlob(int handle, String keyBlob);
    private native boolean setNativePublicKeyModulus(int handle, String keyModulus);
    private native boolean setNativePublicKeyDER(int handle, String keyDer);
    private native boolean setNativePublicKeyBlob(int handle, String keyBlob);
    
    private native boolean setNativePublicKeyECC(int handle, String x, String y);
    
    private native void setNativeKbdType(int handle, short kbdType);
    private native void setNativeKbdStyle(int handle, short kbdStyle);
    private native void setNativeKbdMode(int handle, short kbdMode);
    private native void setNativeContentType(int handle, int contentType);
    
    //private native void setNativeCharText(int[] charText);

    private native long getNativeVersion(int handle);
    private native short getNativeVerify(int handle);

    private native short  getNativeContentLen(int handle);
    private native int  clearNativePlaintext(int handle);
    private native char getNativeDegree(int handle);
    private native String getNativeContent(int handle, String timestamp);
    private native String getNativePinContent(int handle, String timestamp);
    private native String getNativeLastError(int handle);
    private native String getNativeMeasureValue(int handle);
    private native short  getNativeEncryptType(int handle);
    private native short  getNativeHeightType();
    
    private native void setNativeChallengeCode(int handle, byte[] code);
    private native void setNativeKbdFactor(int handle, String factor);
    private native byte[] getNativeEncryptedPinCode(int handle);
    private native void setNativeMode(int handle, short mode);
    
    private native void setNativeAlgorithmCode(int handle, String algorithmCode);
    private native void setNativeHashRandom(int handle, String salt);
    
    private native void setNativeDictionaryFilter(int handle, String dictFilter);
    private native void setNativePopMode(int handle, boolean popFlag);
    private native void setNativeSwitchMode(int handle, short mode);
    private native void setNativeFinishMode(int handle, short mode);
    
    
    
    private native String[] getNativeMessages();
    
    static {
        System.loadLibrary(CBuildConfig.loadLibraryName);
    }
}
