package cn.cloudcore.iprotect.utils;

import java.util.UUID;

import android.app.Activity;
import android.content.Context;
import android.content.ContextWrapper;
import android.os.Build;
import android.util.Base64;
import android.util.Log;

/**
 * Created by boonie on 2017/7/18.
 */

public class CommonUtils {

    /**
     * 16进制字符串转换为base64编码字符串
     *
     * @param strHex
     * @return
     */
    public static String HexToBase64(String strHex) {
        if (strHex == null || strHex.length() == 0) {
            return null;
        }

        if ((strHex.length() % 2) != 0) {
            return null;
        }

        byte[] bStr = HexString2Bytes(strHex);

        return Base64.encodeToString(bStr, Base64.NO_WRAP);
    }

    /**
     * base64编码字符串转换为16进制字符串
     *
     * @param strBase64
     * @return
     */

    public static String Base64ToHex(String strBase64) {
        if (strBase64 == null || strBase64.length() == 0) {
            return null;
        }

        byte[] bStr = Base64.decode(strBase64, Base64.NO_WRAP);
        if (bStr == null) {
            return null;
        }

        return Bytes2HexString(bStr);
    }

    private static byte uniteBytes(byte src0, byte src1) {
        byte _b0 = Byte.decode("0x" + new String(new byte[] { src0 })).byteValue();
        _b0 = (byte) (_b0 << 4);
        byte _b1 = Byte.decode("0x" + new String(new byte[] { src1 })).byteValue();
        byte ret = (byte) (_b0 ^ _b1);
        return ret;
    }

    private static byte[] HexString2Bytes(String src) {
        byte[] ret = new byte[src.length() / 2];
        byte[] tmp = src.getBytes();

        for (int i = 0; i < ret.length; ++i) {
            ret[i] = uniteBytes(tmp[i * 2], tmp[i * 2 + 1]);
        }

        return ret;
    }

    private static String Bytes2HexString(byte[] b) {
        String ret = "";

        for (int i = 0; i < b.length; ++i) {
            String hex = Integer.toHexString(b[i] & 255);
            if (hex.length() == 1) {
                hex = '0' + hex;
            }

            ret = ret + hex.toUpperCase();
        }

        return ret;
    }

    private static Activity getActivity(Context context) {
        while (!(context instanceof Activity) && context instanceof ContextWrapper) {
            context = ((ContextWrapper) context).getBaseContext();
        }

        if (context instanceof Activity) {
            return (Activity) context;
        }

        return (Activity) context;
    }

    /**
     * @param rand
     *            true由随机数生成设备ID，false：由系统特定生成，唯一不变。
     */
    public static String deviceID(Context context, boolean rand, String appModulus, String timestamp) {

        String uniqueID = null;
        //if (rand == false) {
            uniqueID = getUniquePsuedoID();
            uniqueID.replaceAll("-", "");
        //}

        Activity activity = getActivity(context);
        String id = nativeDeviceID(activity, rand, uniqueID, appModulus, timestamp);
        return id;
    }

    public static String getUniquePsuedoID() {
        String serial = "serial"; // default value

        String m_szDevIDShort = "35" + Build.BOARD.length() % 10 + Build.BRAND.length() % 10
                + Build.CPU_ABI.length() % 10 + Build.DEVICE.length() % 10 + Build.DISPLAY.length() % 10
                + Build.HOST.length() % 10 + Build.ID.length() % 10 + Build.MANUFACTURER.length() % 10
                + Build.MODEL.length() % 10 + Build.PRODUCT.length() % 10 + Build.TAGS.length() % 10
                + Build.TYPE.length() % 10 + Build.USER.length() % 10; // 13 位
        try {
            serial = android.os.Build.class.getField("SERIAL").get(null).toString();
            // return new UUID(m_szDevIDShort.hashCode(), serial.hashCode()).toString();
            return serial;
        } catch (Exception exception) {
        }

        // 使用硬件信息拼凑出来的15位号码
        return new UUID(m_szDevIDShort.hashCode(), serial.hashCode()).toString();
    }

    private native static String nativeDeviceID(Context context, boolean rand, String uniqueID, String appModulus,
            String timestamp);

    static {
        System.loadLibrary(CBuildConfig.loadLibraryName);
    }
}
