package cn.cloudcore.iprotect.view;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.content.Context;

import android.graphics.PixelFormat;
import android.opengl.GLSurfaceView;
import android.util.AttributeSet;
import cn.cloudcore.iprotect.plugin.CEditTextAttrSet;
import cn.cloudcore.iprotect.plugin.CKbdJniLib;

public class CKeyBoardTopLayer extends GLSurfaceView {

    public int    defaultHandle               = -1;
    public String defaultName                 = "CloudCoreDefault";
    
    private  CKbdJniLib cKbdJniLib             = null;
    private boolean hasInitialized      = false;
    
    public CKeyBoardTopLayer(Context context) {
        super(context);
        onConstruct(context);
    }
    
    public CKeyBoardTopLayer(Context context, AttributeSet attrs) {
        super(context, attrs);
        onConstruct(context);
    }
    
    public boolean onConstruct(Context context) {
        
        setZOrderOnTop(true);
        setEGLConfigChooser(8, 8, 8, 8, 16, 0);
        getHolder().setFormat(PixelFormat.TRANSLUCENT);
        
        cKbdJniLib    = new CKbdJniLib(defaultName);
        defaultHandle = cKbdJniLib.kbd_handle;

        CKeyBoardRenderer cKeyBoardRenderer = new CKeyBoardRenderer();
        setRenderer(cKeyBoardRenderer);
        
        return true;
    }
    
    public void onInitialize(CEditTextAttrSet attrSet) {
        CKbdJniLib jniLib = new CKbdJniLib(attrSet.name);
        
        cKbdJniLib = jniLib;
    }
    
    
    
    class CKeyBoardRenderer implements GLSurfaceView.Renderer {

        public void onSurfaceCreated(GL10 gl, EGLConfig config) {
            cKbdJniLib.setPopTopSurfaceCreated();
            hasInitialized = true;
        }

        public void onSurfaceChanged(GL10 gl, int width, int height) {
            cKbdJniLib.setPopTopSurfaceChanged(width, height);
        }

        public void onDrawFrame(GL10 gl) {
            if (!hasInitialized) {
                cKbdJniLib.setPopTopSurfaceCreated();
                hasInitialized = true;
            }
            
            cKbdJniLib.setPopTopDrawFrame();
        }
    }
}
