package cn.cloudcore.iprotect.view;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Paint.Style;
import android.util.AttributeSet;
import android.view.View;

public class CircleView extends View {

    private float circleRadius = 0.0f;
    private int   cirCleColor  = Color.BLACK;
    
    public CircleView(Context context) {
        super(context);
    }

    public CircleView(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    public CircleView(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }

    @SuppressLint("NewApi")
    public CircleView(Context context, AttributeSet attrs, int defStyleAttr,
            int defStyleRes) {
        super(context, attrs, defStyleAttr, defStyleRes);
    }

    public void setCircleRadius(float circleRadius) {
        this.circleRadius = circleRadius;
    }
    
    public void setCirCleColor(int cirCleColor) {
        this.cirCleColor = cirCleColor;
    }
    
    @Override
    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
        
        int verticalCenter = getHeight() / 2;
        int horizontalCenter = getWidth() / 2;
        
        float radius = horizontalCenter < verticalCenter ? 
                horizontalCenter : verticalCenter;
        if (circleRadius > 0.0001f) {
            radius = circleRadius;
        }
        
        Paint paint = new Paint();
        paint.setAntiAlias(true);// 抗锯齿
        paint.setStyle(Style.FILL);
        paint.setColor(cirCleColor);
        canvas.drawCircle(horizontalCenter, verticalCenter, circleRadius, paint);
    }
}